# GitLab CI in conjunction with GitLab Runner can use Docker Engine to test and build any application.
# Docker, when used with GitLab CI, runs each job in a separate and isolated container using the predefined image that is set up in .gitlab-ci.yml.
# In this case we use the latest python docker image to build and test this project.
image: $SKA_K8S_TOOLS_BUILD_DEPLOY

default:
  tags:
    - k8srunner

# Standardised included jobs
variables:
  CHARTS_TO_PUBLISH: ska-oso-scripting
  GIT_SUBMODULE_STRATEGY: recursive

# The YAML file defines a set of jobs with constraints stating when they should be run.
# You can specify an unlimited number of jobs which are defined as top-level elements with an arbitrary name and always have to contain at least the script clause.
# In this case we have only the test job which produce an artifacts (it must be placed into a directory called "public")
# It is also specified that only the master branch will be subject of this job.

stages:
  - build
  - test
  - deploy
  - lint
  - publish
  - pages
  - scan
  - integration
  - staging

# see STS-757
python-lint:
  image: $SKA_K8S_TOOLS_BUILD_DEPLOY

# see STS-757
python-test:
  image: $SKA_K8S_TOOLS_BUILD_DEPLOY

xray-publish:
  variables:
    XRAY_TEST_RESULT_FILE: build/cucumber.json
  rules:
  - if: '$CI_COMMIT_REF_NAME == "master"'
    when: always
  - if: '$CI_COMMIT_REF_NAME != "master"'
    when: manual

include:
  # Python
  - project: "ska-telescope/templates-repository"
    file: "gitlab-ci/includes/python.gitlab-ci.yml"
  # OCI
  - project: "ska-telescope/templates-repository"
    file: "gitlab-ci/includes/oci-image.gitlab-ci.yml"
  # Selected Helm chart steps - don't include publish as ska-oso-scripting is not a deployable artefact
  - project: 'ska-telescope/templates-repository'
    file: 'gitlab-ci/includes/helm-chart-lint.gitlab-ci.yml'
  - project: 'ska-telescope/templates-repository'
    file: 'gitlab-ci/includes/helm-chart-build.gitlab-ci.yml'
  # k8s steps
  - project: 'ska-telescope/templates-repository'
    file: 'gitlab-ci/includes/k8s.gitlab-ci.yml'
  # Docs pages
  - project: 'ska-telescope/templates-repository'
    file: 'gitlab-ci/includes/docs.gitlab-ci.yml'
  # release automation
  - project: 'ska-telescope/templates-repository'
    file: 'gitlab-ci/includes/release.gitlab-ci.yml'
  # Upload BDD test results to JIRA X-ray
  - project: "ska-telescope/templates-repository"
    file: "gitlab-ci/includes/xray-publish.gitlab-ci.yml"
  # .post step finalisers eg: badges
  - project: "ska-telescope/templates-repository"
    file: "gitlab-ci/includes/finaliser.gitlab-ci.yml"